// MQL4&5-code

#property strict

#define PRINT(A) ::Print(#A + " = " + (string)(A));

#ifdef __MQL4__
  template <typename T>
  void ArrayPrint( const T &Array[] )
  {
    string Str = "";

    const int Size = ArraySize(Array);

    for (int i = 0; i < Size; i++)
      Str += " " + (string)Array[i];

    Print(Str);

    return;
  }
#endif

//   
struct STRUCT
{
  int i;

  //   
  void operator =( const STRUCT& ) {}
};

struct STRUCT2
{
  MqlTick Tick;
};

#define TYPETOBYTES_FULL_SLOW
#include <TypeToBytes.mqh>

void OnStart( void )
{
  MqlTick Tick;
  SymbolInfoTick(Symbol(), Tick);

  MqlTick CloneTick = Tick;

//   
  if (_R(Tick) == CloneTick)             //    
    ::Print("Equal");

//      
  PRINT(_R(Tick)[(datetime)0])           //   datetime       MqlTick - Tick.time

//    
  const int Offset = _OFFSET(Tick, bid); //      bid    MqlTick

  PRINT(Tick.bid)                        //   Tick.bid
  _W(Tick)[Offset] = 1.23456;            //      (double)1.23456

  PRINT(Tick.bid)                        // ,  Tick.bid   1.23456

  PRINT(_R(Tick)[(double)Offset])        //   double,    Offset -   Tick.bid

  PRINT(_R(Tick).Bytes[8])               //      8    MqlTick
  PRINT(_R(Tick)[(uchar)8])              //   ,   

  PRINT(CloneTick.bid)                   //   CloneTick.bid
  _W(CloneTick)[0] = Tick;               //   CloneTick       Tick
  PRINT(CloneTick.bid)                   // ,  CloneTick.bid == Tick.bid

//    
  color Color = C'241,248,255';

  PRINT(_R(Color)[(uchar)1])             // Green-  - 248

  _W(Color)[2] = (uchar)230;             //    2  (uchar)230.
  PRINT(Color)                           // ,  Color  C'241,248,230'

//     
  PRINT((_R(Tick) != Color))             //       

//   
  int i = 0;
  _W(i) = (float)12.34;                  //   int-    (float)12.34
  PRINT(i)                               // ,   1095069860

  float f = 0;
  _W(f) = i;                             //   float-      (int)1095069860
  PRINT(f)                               // ,      - (float)12.34

  ArrayPrint(_R(256).Bytes);             //     (int)256

//   
  short Array[] = {1, 2, 3};
  ArrayPrint(_R(Array).Bytes);           //     Array

  PRINT((_R(Array) == _R(Array).Bytes))  // ,     .

  _W(Color) = Array;                     //    Array  Color
  PRINT(Color)                           // ,  Color  C'1,0,2'
  ArrayPrint(_R(Color).Bytes);           //    Color

  uchar Array2[];
  ArrayCopy(Array2, _R(Tick).Bytes);     //   Array2   Tick
  PRINT((_R(Tick) == Array2))            // ,  Tick  Array2  

  MqlTick Tick2 = {0};
  _W(Tick2) = Array2;                    //   Tick2  Array2
  PRINT((_R(Tick) == Tick2))             // ,  Tick  Tick2 

  int Array3[] = {INT_MIN, INT_MAX};
  ArrayPrint(_R(Array3).Bytes);          //     Array3
  ArrayPrint(_R(Array).Bytes);           //     Array

  _ArrayCopy(Array3, Array);             //    Array   Array3
  ArrayPrint(_R(Array3).Bytes);          // ,     Array3 

//   
  string Str = "abcd";

  _W(i) = Str;                           //   (int)i  

  PRINT((_R(i) == Str))                  //   int  sring

  ArrayPrint(_R(i).Bytes);               //   i
  ArrayPrint(_R(Str).Bytes);             //   Str

  PRINT(_R(Str)[(short)1])               //  short-   1   Str

  PRINT(Str)
  _W(Str)[2] = "98765";                  //        2
  PRINT(Str)

  string StrArray[] = {"123", "45", "6789"};
  _W(Str) = StrArray;                    //     
  PRINT(Str)

  _W(Str)[3] = (uchar)0;                 //     3  ,     ( - 3 ANSI- (4 ))
  PRINT(Str);

//        _R-  -  TYPETOBYTES_FULL_SLOW
  STRUCT Struct;                         //      
  Struct.i = 1;

  ArrayPrint(_R(Struct).Bytes);          // ,   
  PRINT(_R(Struct) == Struct)            //    _R- 

//  ""   
  PRINT(_WRONG_ASSIGN_OPERATOR(int))     // 
  PRINT(_WRONG_ASSIGN_OPERATOR(MqlTick)) // 
  PRINT(_WRONG_ASSIGN_OPERATOR(STRUCT))  //  

//     (       -  TYPETOBYTES_FULL_SLOW)
  STRUCT2 Struct2 = _C(STRUCT2, Tick);   //    STRUCT2 Struct2 = (STRUCT2)Tick;
  PRINT(_R(Struct2) == Tick)             // ,  Struct2 == Tick

  Struct2.Tick.time = __DATETIME__;      //  Struct2
  PRINT(_R(Struct2) == Tick)             // ,  Struct2 != Tick

  _W(Struct2) = Tick;                    //   Tick  Struct2
  PRINT(_R(Struct2) == Tick)             // ,  Struct2 == Tick

  return;
}